#include <windows.h>
#include <stdio.h>
#include <tchar.h>

int __cdecl _tmain()
{
    HANDLE hEvent ;
    HANDLE hFile ;
    HANDLE hDrive ;
    LPVOID buffer ;
    DISK_GEOMETRY dg ;
    OVERLAPPED ovl ;

    hDrive = CreateFile(TEXT("\\\\.\\a:"), GENERIC_READ, FILE_SHARE_READ, 
	    NULL, OPEN_EXISTING, FILE_ATTRIBUTE_DEVICE |
	    FILE_FLAG_OVERLAPPED, NULL) ;
    if (hDrive == INVALID_HANDLE_VALUE)
	return 0 ;
    hFile = CreateFile(TEXT("Wtcmnt4.ima"), GENERIC_WRITE, 
	    FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, 
	    FILE_ATTRIBUTE_ARCHIVE | FILE_FLAG_OVERLAPPED, NULL) ;
    if (hFile == INVALID_HANDLE_VALUE)
	return 0 ;

    hEvent = CreateEvent(NULL, FALSE, FALSE, TEXT("MyEvent")) ;

    if (!hEvent)
    {
	FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_ALLOCATE_BUFFER, 0, GetLastError(), MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR)&buffer, 0, NULL) ;
	_tprintf((TCHAR *)buffer) ;
	LocalFree(buffer) ;
    }

    ZeroMemory(&ovl, sizeof(OVERLAPPED)) ;
    ovl.Offset = 0 ;
    ovl.OffsetHigh = 0 ;
    ovl.hEvent = hEvent ; 
    
    _tprintf(TEXT("Handle %u, %u\r"), hEvent, hDrive) ;
    CloseHandle(hEvent) ;
    CloseHandle(hDrive) ;
    CloseHandle (hFile) ;
    return 0 ;
}
